/***  Lightness1024! ProgrammatO E.U.R.L.    ***/
/*** module de la classe template SecureArray ***/

/*
----------------------------------------------------
Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".
(...)
Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
pris connaissance de la licence CeCILL, et que vous en avez accept les
termes.

lightness1024@free.fr
--------------------------------------------------------
*/

#include "SecureArray.hpp"

//---- fonctions membres de OutOfRangeException ----

OutOfRangeException::OutOfRangeException(int BadIndex, int Elements, const char* ErrorString)
{
	this->BadIndex = BadIndex;
	this->Elements = Elements;
	this->ErrorString = ErrorString;
}

void OutOfRangeException::GetErrorStringPtr(char* buffer, int BuffSize)
{
	int ar[2];
	va_list lst;
	
	if (BuffSize < (signed)strlen(ErrorString) + 30)
	{
		strncpy(buffer, "erreur accs index", BuffSize - 1);
		buffer[BuffSize - 1] = 0;
		return;
	}
	ar[0] = BadIndex;
	ar[1] = Elements;
	lst = (va_list)ar;
	vsprintf(buffer, ErrorString, lst);
}

int OutOfRangeException::GetBadIndex(void)
{
	return BadIndex;
}

int OutOfRangeException::GetElements(void)
{
	return Elements;
}
