/**********************************************************************
 * File  : randclass.hpp
 * Author: Vivien - a.k.a. Lightness1024!
 *         mailto:lightness1024@free.fr
 * Date  : 10/07/2007
 *********************************************************************/

#ifndef CRANDOM_NOVEND
#define CRANDOM_NOVEND 1

class CRandom
{
		int current;

	public:

		unsigned int Get(int ubound = 32768)
		{
			current = current * 1103515245 + 12345;
			return ((unsigned)(current / 65536) % 32768) * (ubound + 1) / 32769;
		}
		void SetSeed(int seed)
		{
			current = seed;
		}
		
		CRandom(int seed = 0) : current(seed) { }
};

#endif
